/*!
@angular-dynaform/material 0.2.3 2017-11-12T16:09:59.942Z 
*/
import { ControlType, DynamicForm, DynamicFormControlComponent, DynamicFormControlComponentBase, DynamicFormErrorComponent, DynamicFormFormControlComponent, DynamicFormModule, DynamicFormService } from '@angular-dynaform/core';
import { CommonModule } from '@angular/common';
import { Component, NgModule } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { MatButtonModule, MatCheckboxModule, MatDatepickerModule, MatInputModule, MatNativeDateModule, MatRadioModule, MatSelectModule, MatSlideToggleModule, MatSliderModule, MatStepperModule, MatTabsModule } from '@angular/material';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialArrayComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialArrayComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-array-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <fieldset
        [id]="model.id"
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
        <legend
          *ngIf="model.local.label"
          [ngClass]="model.css.label"
          [innerHTML]="model.local.label"
        ></legend>
        <adf-group-container
          *ngIf="model.header"
          [ngClass]="model.header.css.content"
          [model]="model.header"
        >
        </adf-group-container>
        <adf-error-container [model]="model">
        </adf-error-container>
        <div
          [formArrayName]="model.key"
          [ngClass]="model.css.content"
        >
          <ng-container
            *ngFor="let item of model.items; let i=index"
            [formGroupName]="i"
          >
            <adf-group-container
              [ngClass]="item.css.content"
              [model]="item"
            >
            </adf-group-container>
          </ng-container>
        </div>
        <adf-group-container
          *ngIf="model.footer"
          [ngClass]="model.footer.css.content"
          [model]="model.footer"
        >
        </adf-group-container>
      </fieldset>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialArrayComponent }]
            },] },
];
/** @nocollapse */
MaterialArrayComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialButtonComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-button-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <button mat-raised-button
        [formControlName]="model.key"
        [id]="model.id"
        [ngClass]="model.css.control"
        [type]="buttonType"

        adfHTMLDomElement
        ngDefaultControl
      >
        <span [ngClass]="model.css.control"
          [innerHTML]="model.local.label"
        ></span>
      </button>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialButtonComponent }]
            },] },
];
/** @nocollapse */
MaterialButtonComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialCheckboxComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialCheckboxComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-checkbox-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <mat-checkbox
        [formControlName]="model.key"
        [id]="model.id"
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
      </mat-checkbox>
      <label
        [attr.for]="model.id"
        class="adf-back"
        [ngClass]="model.css.label"
      >
        <span [ngClass]="model.css.label"
          [innerHTML]="model.local.label">
        </span>
      </label>
      <adf-error-container [model]="model">
      </adf-error-container>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialCheckboxComponent }]
            },] },
];
/** @nocollapse */
MaterialCheckboxComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialDatepickerComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialDatepickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-input-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-form-field [ngClass]="model.css.control">
        <input matInput
          [formControlName]="model.key"
          [id]="model.id"
          type="text"
          [readonly]="options.readOnly"
          [maxlength]="options.maxLength"
          [placeholder]="model.local.placeholder"
          [ngClass]="model.css.control"
          adfHTMLDomElement
          [matDatepicker]="myDatepicker"
        />
          <mat-datepicker-toggle matSuffix [for]="myDatepicker"></mat-datepicker-toggle>
          <mat-datepicker #myDatepicker></mat-datepicker>
          <adf-error-container [model]="model">
          </adf-error-container>
        </mat-form-field>
  </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialDatepickerComponent }]
            },] },
];
/** @nocollapse */
MaterialDatepickerComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialDivisionComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialDivisionComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-division-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
        <div
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
        <adf-error-container [model]="model">
        </adf-error-container>
        <adf-group-container
          [model]="model"
          [ngClass]="model.css.content"
        >
        </adf-group-container>
      </div>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialDivisionComponent }]
            },] },
];
/** @nocollapse */
MaterialDivisionComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-life-cycle-interface
// TODO: add class 'mat-input-error'
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialErrorComponent extends DynamicFormErrorComponent {
    /**
     * @param {?} form
     */
    constructor(form) {
        super(form);
        this.form = form;
    }
}
MaterialErrorComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-error-component',
                template: `
    <mat-error [ngClass]="model.css.error" [innerHTML]="error.message"></mat-error>
  `,
                inputs: ['model', 'error'],
                providers: [{ provide: DynamicFormErrorComponent, useExisting: MaterialErrorComponent }]
            },] },
];
/** @nocollapse */
MaterialErrorComponent.ctorParameters = () => [
    { type: DynamicForm, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialFieldsetComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialFieldsetComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-fieldset-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <fieldset
        [id]="model.id"
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
        <legend
          *ngIf="model.local.label"
          [ngClass]="model.css.label"
          [innerHTML]="model.local.label"
        >
        </legend>
        <adf-error-container [model]="model">
        </adf-error-container>
        <adf-group-container
          [model]="model"
          [ngClass]="model.css.content"
        >
        </adf-group-container>
      </fieldset>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialFieldsetComponent }]
            },] },
];
/** @nocollapse */
MaterialFieldsetComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
// import { Component, EventEmitter, Output } from '@angular/core';
class MaterialFormComponent extends DynamicFormFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialFormComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-form-component',
                template: `
    <div
      [ngClass]="model.css.container"
    >
      <form
        [formGroup]="model.ngControl"
        [id]="model.id"
        [ngClass]="model.css.control"
        (ngSubmit)="onSubmit($event)"
        (reset)="onReset($event)"

        adfHTMLDomElement
        novalidate
      >
        <adf-group-container
          [ngClass]="model.css.content"
          [model]="model"
        >
        </adf-group-container>
      </form>
    </div>
  `,
                inputs: ['model'],
                outputs: ['submit', 'reset'],
                providers: [
                    {
                        provide: DynamicFormControlComponentBase,
                        useExisting: MaterialFormComponent
                    },
                    // required to support 'adfHTMLDomElement' directive
                    { provide: DynamicFormFormControlComponent, useExisting: MaterialFormComponent }
                ]
            },] },
];
/** @nocollapse */
MaterialFormComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialInputComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-input-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-form-field [ngClass]="model.css.control">
        <input matInput
          [formControlName]="model.key"
          [id]="model.id"
          [type]="options.inputType || 'text'"
          [readonly]="options.readOnly"
          [maxlength]="options.maxLength"
          [attr.autocomplete]="model.autoComplete"
          [placeholder]="model.local.placeholder"
          [ngClass]="model.css.control"
          adfHTMLDomElement
        />
        <!--
          [minlength]="options.minLength"
          [min]="options.min"
          [max]="options.max"
          [step]="options.step"
        -->
          <adf-error-container [model]="model">
          </adf-error-container>
        </mat-form-field>
  </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialInputComponent }]
            },] },
];
/** @nocollapse */
MaterialInputComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialRadioGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialRadioGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-radiogroup-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <mat-radio-group
        [id]="model.id"
        [formControlName]="model.key"
        ngDefaultControl
        adfHTMLDomElement
        [ngClass]="model.css.control"
      >
        <mat-radio-button *ngFor="let opt of model.local.valueOptions"
          [value]="opt.value"
        >
          <span [innerHTML]="opt.label"></span>
        </mat-radio-button>
      </mat-radio-group>
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-back-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <adf-error-container [model]="model">
      </adf-error-container>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialRadioGroupComponent }]
            },] },
];
/** @nocollapse */
MaterialRadioGroupComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialSelectComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialSelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-select-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-form-field [ngClass]="model.css.control">
        <mat-select
          [formControlName]="model.key"
          [id]="model.id"
          [placeholder]="model.local.placeholder"
          [multiple]="options.multiple"
          [ngClass]="model.css.control"
          adfHTMLDomElement
        >
          <mat-option *ngFor="let opt of model.local.valueOptions" [value]="opt.value"><span [innerHTML]="opt.label"></span></mat-option>
        </mat-select>
        <adf-error-container [model]="model">
        </adf-error-container>
      </mat-form-field>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialSelectComponent }]
            },] },
];
/** @nocollapse */
MaterialSelectComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialSeparatorComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialSeparatorComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-separator-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <span [ngClass]="model.css.control"
        [innerHTML]="model.local.label"
      ></span>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialSeparatorComponent }]
            },] },
];
/** @nocollapse */
MaterialSeparatorComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialSliderComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialSliderComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-input-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-slider
        [formControlName]="model.key"
        [id]="model.id"
        [min]="options.min"
        [max]="options.max"
        [step]="options.step"
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
      </mat-slider>
      <adf-error-container [model]="model">
      </adf-error-container>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialSliderComponent }]
            },] },
];
/** @nocollapse */
MaterialSliderComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class MaterialStepperComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialStepperComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-tab-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <div
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
        <adf-error-container [model]="model">
        </adf-error-container>
        <mat-horizontal-stepper adfHTMLDomElement [ngClass]="model.css.content">
          <mat-step *ngFor="let item of model.items; let i=index"
            [stepControl]="item.ngControl"
          >
            <ng-template matStepLabel>{{item.local.label}}</ng-template>
            <ng-template
              adfControlComponent
              [model]="item"
            >
            </ng-template>
          </mat-step>
        </mat-horizontal-stepper>
      </div>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialStepperComponent }]
            },] },
];
/** @nocollapse */
MaterialStepperComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialSwitchComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialSwitchComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-input-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-slide-toggle
        [formControlName]="model.key"
        [id]="model.id"
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
      </mat-slide-toggle>
      <adf-error-container [model]="model">
      </adf-error-container>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialSwitchComponent }]
            },] },
];
/** @nocollapse */
MaterialSwitchComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class MaterialTabGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialTabGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-tab-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <div
        [ngClass]="model.css.control"
        adfHTMLDomElement
      >
        <adf-error-container [model]="model">
        </adf-error-container>
        <mat-tab-group adfHTMLDomElement [ngClass]="model.css.content">
          <mat-tab *ngFor="let item of model.items;" >
            <ng-template mat-tab-label>{{item.local.label}}</ng-template>
            <ng-template
              adfControlComponent
              [model]="item"
            >
            </ng-template>
          </mat-tab>
        </mat-tab-group>
      </div>
    </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialTabGroupComponent }]
            },] },
];
/** @nocollapse */
MaterialTabGroupComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable use-input-property-decorator use-output-property-decorator no-access-missing-member
class MaterialTextareaComponent extends DynamicFormControlComponent {
    /**
     * @param {?} form
     * @param {?} dynamicFormService
     */
    constructor(form, dynamicFormService) {
        super(form, dynamicFormService);
        this.form = form;
        this.dynamicFormService = dynamicFormService;
    }
}
MaterialTextareaComponent.decorators = [
    { type: Component, args: [{
                selector: 'adf-material-textarea-component',
                template: `
    <div
      [formGroup]="model.ngGroup"
      [ngClass]="model.css.container"
      [hidden]="model.hidden"
    >
      <label
        *ngIf="model.local.label"
        [attr.for]="model.id"
        class="adf-front-label"
        [ngClass]="model.css.label"
        [innerHTML]="model.local.label"
      ></label>
      <mat-form-field [ngClass]="model.css.control">
        <textarea matInput
          [formControlName]="model.key"
          [id]="model.id"
          [maxlength]="options.maxLength"
          [minlength]="options.minLength"
          [readonly]="options.readOnly"
          [wrap]="options.wrap"
          [cols]="options.cols"
          [rows]="options.rows"
          [placeholder]="model.local.placeholder"
          [ngClass]="model.css.control"
          adfHTMLDomElement
        >
        </textarea>
        <adf-error-container [model]="model">
        </adf-error-container>
      </mat-form-field>
  </div>
  `,
                inputs: ['model'],
                providers: [{ provide: DynamicFormControlComponentBase, useExisting: MaterialTextareaComponent }]
            },] },
];
/** @nocollapse */
MaterialTextareaComponent.ctorParameters = () => [
    { type: DynamicForm, },
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/** @enum {string} */
const MaterialControlType = {
    CONTROL_UNKNOWN: 'mat:unknown',
    // controls for group or subset model:
    CONTROL_DIVISION: 'mat:division',
    CONTROL_FIELDSET: 'mat:fieldset',
    CONTROL_TABGROUP: 'mat:tabgroup',
    CONTROL_STEPPER: 'mat:stepper',
    // controls for array model:
    CONTROL_ARRAY: 'mat:array',
    // controls for value model:
    CONTROL_CHECKBOX: 'mat:checkbox',
    CONTROL_INPUT: 'mat:input',
    CONTROL_RADIOGROUP: 'mat:radiogroup',
    CONTROL_SELECT: 'mat:select',
    CONTROL_SLIDER: 'mat:slider',
    CONTROL_SWITCH: 'mat:switch',
    CONTROL_TEXTAREA: 'mat:textarea',
    CONTROL_DATEPICKER: 'mat:datepicker',
    CONTROL_TIMEPICKER: 'mat:timepicker',
    CONTROL_LISTPICKER: 'mat:listpicker',
    CONTROL_UPLOAD: 'mat:upload',
    // controls for null model:
    CONTROL_BUTTON: 'mat:button',
    CONTROL_SEPARATOR: 'mat:separator',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
const moduleDeclarations = [
    MaterialFormComponent, MaterialErrorComponent, MaterialArrayComponent, MaterialDivisionComponent,
    MaterialFieldsetComponent, MaterialButtonComponent, MaterialCheckboxComponent, MaterialInputComponent,
    MaterialRadioGroupComponent, MaterialSelectComponent, MaterialSeparatorComponent, MaterialSliderComponent,
    MaterialSwitchComponent, MaterialTextareaComponent, MaterialDatepickerComponent, MaterialTabGroupComponent,
    MaterialStepperComponent
];
class DynamicMaterialFormModule {
    /**
     * @param {?} dynamicFormService
     */
    constructor(dynamicFormService) {
        this.dynamicFormService = dynamicFormService;
        this.dynamicFormService.setFormControlComponent(MaterialFormComponent, true);
        this.dynamicFormService.setErrorComponent(MaterialErrorComponent, true);
        // register default control components:
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_ARRAY, MaterialArrayComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_FIELDSET, MaterialFieldsetComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_DIVISION, MaterialDivisionComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_TABGROUP, MaterialTabGroupComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_STEPPER, MaterialStepperComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_BUTTON, MaterialButtonComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_SEPARATOR, MaterialSeparatorComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_CHECKBOX, MaterialCheckboxComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_DATEPICKER, MaterialDatepickerComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_INPUT, MaterialInputComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_RADIOGROUP, MaterialRadioGroupComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_SELECT, MaterialSelectComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_SLIDER, MaterialSliderComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_SWITCH, MaterialSwitchComponent, true);
        this.dynamicFormService.setControlComponent(ControlType.CONTROL_TEXTAREA, MaterialTextareaComponent, true);
        // register material control components:
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_ARRAY, MaterialArrayComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_FIELDSET, MaterialFieldsetComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_DIVISION, MaterialDivisionComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_TABGROUP, MaterialTabGroupComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_STEPPER, MaterialStepperComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_BUTTON, MaterialButtonComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SEPARATOR, MaterialSeparatorComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_CHECKBOX, MaterialCheckboxComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_DATEPICKER, MaterialDatepickerComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_INPUT, MaterialInputComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_RADIOGROUP, MaterialRadioGroupComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SELECT, MaterialSelectComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SLIDER, MaterialSliderComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SWITCH, MaterialSwitchComponent, true);
        this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_TEXTAREA, MaterialTextareaComponent, true);
    }
}
DynamicMaterialFormModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule, ReactiveFormsModule, DynamicFormModule, BrowserAnimationsModule, MatButtonModule, MatCheckboxModule,
                    MatInputModule, MatRadioModule, MatSelectModule, MatSliderModule, MatSlideToggleModule, MatNativeDateModule,
                    MatDatepickerModule, MatTabsModule, MatStepperModule
                ],
                declarations: [moduleDeclarations],
                entryComponents: [moduleDeclarations],
                exports: [moduleDeclarations]
            },] },
];
/** @nocollapse */
DynamicMaterialFormModule.ctorParameters = () => [
    { type: DynamicFormService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { DynamicMaterialFormModule, MaterialArrayComponent, MaterialButtonComponent, MaterialCheckboxComponent, MaterialDivisionComponent, MaterialErrorComponent, MaterialFieldsetComponent, MaterialFormComponent, MaterialInputComponent, MaterialRadioGroupComponent, MaterialSelectComponent, MaterialSeparatorComponent, MaterialSliderComponent, MaterialSwitchComponent, MaterialTextareaComponent, MaterialControlType, MaterialDatepickerComponent as ɵa, MaterialStepperComponent as ɵc, MaterialTabGroupComponent as ɵb };
//# sourceMappingURL=index.js.map
